"use strict";
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const computed_property_get_1 = __importDefault(require("./computed-property-get"));
const computed_property_set_1 = __importDefault(require("./computed-property-set"));
const concat_operator_1 = __importDefault(require("./concat-operator"));
const eval_1 = __importDefault(require("./eval"));
const eval_bind_1 = __importDefault(require("./eval-bind"));
const eval_call_apply_1 = __importDefault(require("./eval-call-apply"));
const eval_get_1 = __importDefault(require("./eval-get"));
const window_eval_get_1 = __importDefault(require("./window-eval-get"));
const post_message_get_1 = __importDefault(require("./post-message-get"));
const window_post_message_get_1 = __importDefault(require("./window-post-message-get"));
const post_message_call_apply_bind_1 = __importDefault(require("./post-message-call-apply-bind"));
const for_in_1 = __importDefault(require("./for-in"));
const for_of_1 = __importDefault(require("./for-of"));
const location_get_1 = __importDefault(require("./location-get"));
const location_set_1 = __importDefault(require("./location-set"));
const property_get_1 = __importDefault(require("./property-get"));
const property_set_1 = __importDefault(require("./property-set"));
const method_call_1 = __importDefault(require("./method-call"));
const js_protocol_last_expression_1 = __importDefault(require("./js-protocol-last-expression"));
const static_import_1 = __importDefault(require("./static-import"));
const dynamic_import_1 = __importDefault(require("./dynamic-import"));
const declaration_destructuring_1 = __importDefault(require("./declaration-destructuring"));
const assignment_destructuring_1 = __importDefault(require("./assignment-destructuring"));
const func_args_destructing_1 = __importDefault(require("./func-args-destructing"));
const esotope_hammerhead_1 = require("esotope-hammerhead");
const TRANSFORMERS = [
    (0, func_args_destructing_1.default)(esotope_hammerhead_1.Syntax.FunctionDeclaration),
    (0, func_args_destructing_1.default)(esotope_hammerhead_1.Syntax.FunctionExpression),
    (0, func_args_destructing_1.default)(esotope_hammerhead_1.Syntax.ArrowFunctionExpression),
    assignment_destructuring_1.default,
    computed_property_get_1.default,
    computed_property_set_1.default,
    concat_operator_1.default,
    eval_1.default,
    eval_bind_1.default,
    eval_call_apply_1.default,
    eval_get_1.default,
    window_eval_get_1.default,
    post_message_get_1.default,
    window_post_message_get_1.default,
    post_message_call_apply_bind_1.default,
    for_in_1.default,
    for_of_1.default,
    location_get_1.default,
    location_set_1.default,
    property_get_1.default,
    property_set_1.default,
    method_call_1.default,
    js_protocol_last_expression_1.default,
    static_import_1.default,
    dynamic_import_1.default,
    declaration_destructuring_1.default,
];
function createTransformerMap() {
    const transformerMap = new Map();
    for (const transformer of TRANSFORMERS) {
        const nodeType = transformer.nodeTypes;
        let transformers = transformerMap.get(nodeType);
        if (!transformers) {
            transformers = [];
            transformerMap.set(nodeType, transformers);
        }
        transformers.push(transformer);
    }
    return transformerMap;
}
exports.default = createTransformerMap();module.exports = exports.default;

