"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const incoming_message_like_1 = __importDefault(require("../../incoming-message-like"));
const builtin_header_names_1 = __importDefault(require("../../builtin-header-names"));
const lowercase_header_names_1 = __importDefault(require("./lowercase-header-names"));
const content_type_1 = require("../../../utils/content-type");
const setBodyMethod = __importStar(require("./set-body-method"));
const PAGE_CONTENT_TYPE = 'text/html; charset=utf-8';
const EMPTY_PAGE_HTML = '<html><body></body></html>';
const ERROR_MOCKING_PAGE_CONTENT = 'An error has occurred in the mocking response function.';
function getContentType(body) {
    if (body !== null && typeof body === 'object')
        return content_type_1.JSON_MIME;
    return PAGE_CONTENT_TYPE;
}
async function default_1(mock) {
    let response = {
        headers: { [builtin_header_names_1.default.contentType]: getContentType(mock.body) },
        statusCode: mock.statusCode,
    };
    if (mock.headers)
        response.headers = Object.assign(response.headers, mock.headers);
    if (mock.body === void 0)
        response.body = EMPTY_PAGE_HTML;
    else if (typeof mock.body === 'function') {
        setBodyMethod.add(response);
        try {
            response = Object.assign(response, await mock.body(mock.requestOptions, response));
        }
        catch (err) {
            response.statusCode = 500;
            mock.hasError = true;
            mock.error = err;
            response.body = Buffer.from(ERROR_MOCKING_PAGE_CONTENT);
        }
        setBodyMethod.remove(response);
    }
    else
        response.body = mock.body;
    response.headers = (0, lowercase_header_names_1.default)(response.headers);
    return new incoming_message_like_1.default(response);
}
exports.default = default_1;module.exports = exports.default;

